Index: t3lib/class.t3lib_tstemplate.php
===================================================================
--- t3lib/class.t3lib_tstemplate.php	(revision 9302)
+++ t3lib/class.t3lib_tstemplate.php	(revision )
@@ -1,29 +1,29 @@
 <?php
 /***************************************************************
-*  Copyright notice
-*
-*  (c) 1999-2010 Kasper Skårhøj (kasperYYYY@typo3.com)
-*  All rights reserved
-*
-*  This script is part of the TYPO3 project. The TYPO3 project is
-*  free software; you can redistribute it and/or modify
-*  it under the terms of the GNU General Public License as published by
-*  the Free Software Foundation; either version 2 of the License, or
-*  (at your option) any later version.
-*
-*  The GNU General Public License can be found at
-*  http://www.gnu.org/copyleft/gpl.html.
-*  A copy is found in the textfile GPL.txt and important notices to the license
-*  from the author is found in LICENSE.txt distributed with these scripts.
-*
-*
-*  This script is distributed in the hope that it will be useful,
-*  but WITHOUT ANY WARRANTY; without even the implied warranty of
-*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-*  GNU General Public License for more details.
-*
-*  This copyright notice MUST APPEAR in all copies of the script!
-***************************************************************/
+ *  Copyright notice
+ *
+ *  (c) 1999-2010 Kasper Skårhøj (kasperYYYY@typo3.com)
+ *  All rights reserved
+ *
+ *  This script is part of the TYPO3 project. The TYPO3 project is
+ *  free software; you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License as published by
+ *  the Free Software Foundation; either version 2 of the License, or
+ *  (at your option) any later version.
+ *
+ *  The GNU General Public License can be found at
+ *  http://www.gnu.org/copyleft/gpl.html.
+ *  A copy is found in the textfile GPL.txt and important notices to the license
+ *  from the author is found in LICENSE.txt distributed with these scripts.
+ *
+ *
+ *  This script is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *  GNU General Public License for more details.
+ *
+ *  This copyright notice MUST APPEAR in all copies of the script!
+ ***************************************************************/
 /**
  * Class with template object that is responsible for generating the template
  *
@@ -38,42 +38,42 @@
  *
  *
  *  109: class t3lib_TStemplate
- *  211:     function init()
+ *  211:	 function init()
- *  249:     function getCurrentPageData()
+ *  249:	 function getCurrentPageData()
- *  266:     function matching($cc)
+ *  266:	 function matching($cc)
- *  290:     function start($theRootLine)
+ *  290:	 function start($theRootLine)
  *
- *              SECTION: Fetching TypoScript code text for the Template Hierarchy
+ *			  SECTION: Fetching TypoScript code text for the Template Hierarchy
- *  406:     function runThroughTemplates($theRootLine,$start_template_uid=0)
+ *  406:	 function runThroughTemplates($theRootLine,$start_template_uid=0)
- *  459:     function processTemplate($row, $idList,$pid,$templateID='',$templateParent='')
+ *  459:	 function processTemplate($row, $idList,$pid,$templateID='',$templateParent='')
- *  580:     function includeStaticTypoScriptSources($idList,$templateID,$pid,$row)
+ *  580:	 function includeStaticTypoScriptSources($idList,$templateID,$pid,$row)
- *  642:     function addExtensionStatics($idList,$templateID,$pid,$row)
+ *  642:	 function addExtensionStatics($idList,$templateID,$pid,$row)
- *  675:     function prependStaticExtra($subrow)
+ *  675:	 function prependStaticExtra($subrow)
- *  688:     function versionOL(&$row)
+ *  688:	 function versionOL(&$row)
  *
- *              SECTION: Parsing TypoScript code text from Template Records into PHP array
+ *			  SECTION: Parsing TypoScript code text from Template Records into PHP array
- *  725:     function generateConfig()
+ *  725:	 function generateConfig()
- *  891:     function procesIncludes()
+ *  891:	 function procesIncludes()
- *  915:     function mergeConstantsFromPageTSconfig($constArray)
+ *  915:	 function mergeConstantsFromPageTSconfig($constArray)
- *  944:     function flattenSetup($setupArray, $prefix, $resourceFlag)
+ *  944:	 function flattenSetup($setupArray, $prefix, $resourceFlag)
- *  968:     function substituteConstants($all)
+ *  968:	 function substituteConstants($all)
- *  991:     function substituteConstantsCallBack($matches)
+ *  991:	 function substituteConstantsCallBack($matches)
  *
- *              SECTION: Various API functions, used from elsewhere in the frontend classes
+ *			  SECTION: Various API functions, used from elsewhere in the frontend classes
- * 1022:     function splitConfArray($conf,$splitCount)
+ * 1022:	 function splitConfArray($conf,$splitCount)
- * 1099:     function getFileName($fileFromSetup)
+ * 1099:	 function getFileName($fileFromSetup)
- * 1156:     function extractFromResources($res,$file)
+ * 1156:	 function extractFromResources($res,$file)
- * 1184:     function checkFile($name,$menuArr)
+ * 1184:	 function checkFile($name,$menuArr)
- * 1201:     function printTitle($title,$no_title=0,$titleFirst=0)
+ * 1201:	 function printTitle($title,$no_title=0,$titleFirst=0)
- * 1224:     function fileContent($fName)
+ * 1224:	 function fileContent($fName)
- * 1244:     function wrap($content,$wrap)
+ * 1244:	 function wrap($content,$wrap)
- * 1258:     function removeQueryString($url)
+ * 1258:	 function removeQueryString($url)
- * 1275:     function sortedKeyList($setupArr, $acceptOnlyProperties=FALSE)
+ * 1275:	 function sortedKeyList($setupArr, $acceptOnlyProperties=FALSE)
  *
- *              SECTION: Functions for creating links
+ *			  SECTION: Functions for creating links
- * 1322:     function linkData($page,$oTarget,$no_cache,$script,$overrideArray='',$addParams='',$typeOverride='')
+ * 1322:	 function linkData($page,$oTarget,$no_cache,$script,$overrideArray='',$addParams='',$typeOverride='')
- * 1449:     function getFromMPmap($pageId=0)
+ * 1449:	 function getFromMPmap($pageId=0)
- * 1485:     function initMPmap_create($id,$MP_array=array(),$level=0)
+ * 1485:	 function initMPmap_create($id,$MP_array=array(),$level=0)
  *
  * TOTAL FUNCTIONS: 28
  * (This index is automatically created/updated by the extension "extdeveval")
@@ -81,21 +81,6 @@
  */
 
 
-
-
-
-
-
-
-
-
-
-
-
-
-
-
-
 /**
  * Template object that is responsible for generating the TypoScript template based on template records.
  *
@@ -104,25 +89,25 @@
  * @subpackage t3lib
  * @see	t3lib_tsparser.php, t3lib_matchcondition.php
  */
-class t3lib_TStemplate	{
+class t3lib_TStemplate {
 
 		// Debugging, analysis:
-	var $tt_track = 1;					// If set, the global tt-timeobject is used to log the performance.
+	var $tt_track = 1; // If set, the global tt-timeobject is used to log the performance.
-	var $forceTemplateParsing=0;		// If set, the template is always rendered. Used from Admin Panel.
+	var $forceTemplateParsing = 0; // If set, the template is always rendered. Used from Admin Panel.
 
 		// Backend Analysis modules settings:
-	var $matchAlternative=array();		// This array is passed on to matchObj by generateConfig(). If it holds elements, they are used for matching instead. See commment at the match-class. Used for backend modules only. Never frontend!
+	var $matchAlternative = array(); // This array is passed on to matchObj by generateConfig(). If it holds elements, they are used for matching instead. See commment at the match-class. Used for backend modules only. Never frontend!
-	var $matchAll=0;					// If set, the match-class matches everything! Used for backend modules only. Never frontend!
+	var $matchAll = 0; // If set, the match-class matches everything! Used for backend modules only. Never frontend!
-	var $parseEditorCfgField=0;			// If set, the Backend Editor Configuration TypoScript is also parsed (this is not needed for the frontend)
+	var $parseEditorCfgField = 0; // If set, the Backend Editor Configuration TypoScript is also parsed (this is not needed for the frontend)
 	var $backend_info = 0;
-	var $getFileName_backPath='';		// Set from the backend - used to set an absolute path (PATH_site) so that relative resources are properly found with getFileName()
+	var $getFileName_backPath = ''; // Set from the backend - used to set an absolute path (PATH_site) so that relative resources are properly found with getFileName()
 
 		// Externally set breakpoints (used by Backend Modules)
-	var $ext_constants_BRP=0;
+	var $ext_constants_BRP = 0;
-	var $ext_config_BRP=0;
+	var $ext_config_BRP = 0;
-	var $ext_editorcfg_BRP=0;
+	var $ext_editorcfg_BRP = 0;
-	var $ext_regLinenumbers=false;
-	var $ext_regComments=false;
+	var $ext_regLinenumbers = FALSE;
+	var $ext_regComments = FALSE;
 
 		// Constants:
 	var $uplPath = 'uploads/tf/';
@@ -130,34 +115,34 @@
 	var $menuclasses = 'gmenu,tmenu,imgmenu,jsmenu';
 
 		// Set Internally:
-	var $whereClause = '';				// This MUST be initialized by the init() function
+	var $whereClause = ''; // This MUST be initialized by the init() function
 	var $debug = 0;
-	var $allowedPaths = array();		// This is the only paths (relative!!) that are allowed for resources in TypoScript. Should all be appended with '/'. You can extend these by the global array TYPO3_CONF_VARS. See init() function.
+	var $allowedPaths = array(); // This is the only paths (relative!!) that are allowed for resources in TypoScript. Should all be appended with '/'. You can extend these by the global array TYPO3_CONF_VARS. See init() function.
-	var $simulationHiddenOrTime=0;		// See init(); Set if preview of some kind is enabled.
+	var $simulationHiddenOrTime = 0; // See init(); Set if preview of some kind is enabled.
 
-	var $loaded = 0;					// Set, if the TypoScript template structure is loaded and OK, see ->start()
+	var $loaded = 0; // Set, if the TypoScript template structure is loaded and OK, see ->start()
-	var $setup = Array(					// Default TypoScript Setup code
-		'styles.' => Array (
+	var $setup = array( // Default TypoScript Setup code
+		'styles.' => array(
 			'insertContent' => 'CONTENT',
-			'insertContent.' => Array (
+			'insertContent.' => array(
 				'table' => 'tt_content',
-				'select.' => Array (
+				'select.' => array(
 					'orderBy' => 'sorting',
 					'where' => 'colPos=0',
 					'languageField' => 'sys_language_uid'
 				)
 			)
 		),
-		'config.' => Array (
+		'config.' => array(
 			'extTarget' => '_top',
 			'stat' => 1,
 			'stat_typeNumList' => '0,1',
 			'uniqueLinkVars' => 1
 		)
 	);
-	var $flatSetup = Array (
+	var $flatSetup = array(
 	);
-	var $const = Array (	// Default TypoScript Constants code:
+	var $const = array( // Default TypoScript Constants code:
 		'_clear' => '<img src="clear.gif" width="1" height="1" alt="" />',
 		'_blackBorderWrap' => '<table border="0" bgcolor="black" cellspacing="0" cellpadding="1"><tr><td> | </td></tr></table>',
 		'_tableWrap' => '<table border="0" cellspacing="0" cellpadding="0"> | </table>',
@@ -168,38 +153,36 @@
 
 
 		// For fetching TypoScript code from template hierarchy before parsing it. Each array contains code field values from template records/files:
-	var $config = array();				// Setup field
+	var $config = array(); // Setup field
-	var $constants = array();			// Constant field
+	var $constants = array(); // Constant field
-	var $editorcfg = array();			// Backend Editor Configuration field
+	var $editorcfg = array(); // Backend Editor Configuration field
 
-	var $hierarchyInfo = array();		// For Template Analyser in backend
+	var $hierarchyInfo = array(); // For Template Analyser in backend
-	var $hierarchyInfoToRoot = array();		// For Template Analyser in backend (setup content only)
+	var $hierarchyInfoToRoot = array(); // For Template Analyser in backend (setup content only)
-	var $nextLevel=0;					// Next-level flag (see runThroughTemplates())
+	var $nextLevel = 0; // Next-level flag (see runThroughTemplates())
-	var $rootId;						// The Page UID of the root page
+	var $rootId; // The Page UID of the root page
-	var $rootLine;						// The rootline from current page to the root page
+	var $rootLine; // The rootline from current page to the root page
-	var $absoluteRootLine;				// Rootline all the way to the root. Set but runThroughTemplates
+	var $absoluteRootLine; // Rootline all the way to the root. Set but runThroughTemplates
-	var $outermostRootlineIndexWithTemplate=0;	// A pointer to the last entry in the rootline where a template was found.
+	var $outermostRootlineIndexWithTemplate = 0; // A pointer to the last entry in the rootline where a template was found.
-	var $rowSum;						// Array of arrays with title/uid of templates in hierarchy
+	var $rowSum; // Array of arrays with title/uid of templates in hierarchy
-	var $resources='';					// Resources for the template hierarchy in a comma list
+	var $resources = ''; // Resources for the template hierarchy in a comma list
-	var $sitetitle='';					// The current site title field.
+	var $sitetitle = ''; // The current site title field.
-	var $sections;						// Tracking all conditions found during parsing of TypoScript. Used for the "all" key in currentPageData
+	var $sections; // Tracking all conditions found during parsing of TypoScript. Used for the "all" key in currentPageData
-	var $sectionsMatch;					// Tracking all matching conditions found
+	var $sectionsMatch; // Tracking all matching conditions found
 
 		// Backend: ts_analyzer
-	var $clearList_const=array();
+	var $clearList_const = array();
-	var $clearList_setup=array();
+	var $clearList_setup = array();
-	var $clearList_editorcfg=array();
+	var $clearList_editorcfg = array();
-	var $parserErrors=array();
+	var $parserErrors = array();
 	var $setup_constants = array();
 
 		// Other:
-	var $fileCache = Array();			// Used by getFileName for caching of references to file resources
-	var $frames = Array();				// Keys are frame names and values are type-values, which must be used to refer correctly to the content of the frames.
+	var $fileCache = array(); // Used by getFileName for caching of references to file resources
+	var $frames = array(); // Keys are frame names and values are type-values, which must be used to refer correctly to the content of the frames.
-	var $MPmap = '';					// Contains mapping of Page id numbers to MP variables.
+	var $MPmap = ''; // Contains mapping of Page id numbers to MP variables.
 
 
-
-
 	/**
 	 * Initialize
 	 * MUST be called directly after creating a new template-object
@@ -207,25 +190,25 @@
 	 * @return	void
 	 * @see tslib_fe::initTemplate()
 	 */
-	function init()	{
+	function init() {
 			// $this->whereClause is used only to select templates from sys_template.
 			// $GLOBALS['SIM_ACCESS_TIME'] is used so that we're able to simulate a later time as a test...
-		$this->whereClause='AND deleted=0 ';
+		$this->whereClause = 'AND deleted=0 ';
-		if (!$GLOBALS['TSFE']->showHiddenRecords)	{
+		if (!$GLOBALS['TSFE']->showHiddenRecords) {
-			$this->whereClause.='AND hidden=0 ';
+			$this->whereClause .= 'AND hidden=0 ';
 		}
-		if ($GLOBALS['TSFE']->showHiddenRecords || $GLOBALS['SIM_ACCESS_TIME']!=$GLOBALS['ACCESS_TIME'])	{	// Set the simulation flag, if simulation is detected!
+		if ($GLOBALS['TSFE']->showHiddenRecords || $GLOBALS['SIM_ACCESS_TIME'] != $GLOBALS['ACCESS_TIME']) { // Set the simulation flag, if simulation is detected!
-			$this->simulationHiddenOrTime=1;
+			$this->simulationHiddenOrTime = 1;
 		}
-		$this->whereClause.= 'AND (starttime<='.$GLOBALS['SIM_ACCESS_TIME'].') AND (endtime=0 OR endtime>'.$GLOBALS['SIM_ACCESS_TIME'].')';
+		$this->whereClause .= 'AND (starttime<=' . $GLOBALS['SIM_ACCESS_TIME'] . ') AND (endtime=0 OR endtime>' . $GLOBALS['SIM_ACCESS_TIME'] . ')';
-		if (!$GLOBALS['TYPO3_CONF_VARS']['GFX']['gdlib'])	{
+		if (!$GLOBALS['TYPO3_CONF_VARS']['GFX']['gdlib']) {
-			$this->menuclasses='tmenu,jsmenu,gmenu';
+			$this->menuclasses = 'tmenu,jsmenu,gmenu';
 		}
 
 			// Sets the paths from where TypoScript resources are allowed to be used:
-		$this->allowedPaths = Array(
+		$this->allowedPaths = array(
 			'media/',
-			$GLOBALS['TYPO3_CONF_VARS']['BE']['fileadminDir'],	// fileadmin/ path
+			$GLOBALS['TYPO3_CONF_VARS']['BE']['fileadminDir'], // fileadmin/ path
 			'uploads/',
 			'typo3temp/',
 			't3lib/fonts/',
@@ -234,10 +217,10 @@
 			TYPO3_mainDir . 'contrib/',
 			'typo3conf/ext/'
 		);
-		if ($GLOBALS['TYPO3_CONF_VARS']['FE']['addAllowedPaths'])	{
+		if ($GLOBALS['TYPO3_CONF_VARS']['FE']['addAllowedPaths']) {
-			$pathArr = t3lib_div::trimExplode(',', $GLOBALS['TYPO3_CONF_VARS']['FE']['addAllowedPaths'], true);
+			$pathArr = t3lib_div::trimExplode(',', $GLOBALS['TYPO3_CONF_VARS']['FE']['addAllowedPaths'], TRUE);
 			foreach ($pathArr as $p) {
-					// Once checked for path, but as this may run from typo3/mod/web/ts/ dir, that'll not work!! So the paths ar uncritically included here.
+				// Once checked for path, but as this may run from typo3/mod/web/ts/ dir, that'll not work!! So the paths ar uncritically included here.
 				$this->allowedPaths[] = $p;
 			}
 		}
@@ -261,7 +244,7 @@
 	 * @see start(), tslib_fe::getFromCache()
 	 */
 	function getCurrentPageData() {
-		$currentPageData = false;
+		$currentPageData = FALSE;
 		if (TYPO3_UseCachingFramework) {
 			$pageSectionCache = $GLOBALS['typo3CacheManager']->getCache('cache_pagesection');
 			/* @var $pageSectionCache t3lib_cache_AbstractCache */
@@ -275,8 +258,8 @@
 			}
 		} else {
 			$res = $GLOBALS['TYPO3_DB']->exec_SELECTquery(
-				'content', 'cache_pagesection', 'page_id='.intval($GLOBALS['TSFE']->id).' AND mpvar_hash='.t3lib_div::md5int($GLOBALS['TSFE']->MP));
+				'content', 'cache_pagesection', 'page_id=' . intval($GLOBALS['TSFE']->id) . ' AND mpvar_hash=' . t3lib_div::md5int($GLOBALS['TSFE']->MP));
-			if ($row = $GLOBALS['TYPO3_DB']->sql_fetch_assoc($res))	{
+			if ($row = $GLOBALS['TYPO3_DB']->sql_fetch_assoc($res)) {
 				$currentPageData = unserialize($row['content']);
 			}
 			$GLOBALS['TYPO3_DB']->sql_free_result($res);
@@ -292,17 +275,17 @@
 	 * @return	array		The input array but with a new key added, "match" which contains the items from the "all" key which when passed to tslib_matchCondition returned true.
 	 * @see t3lib_matchCondition, tslib_fe::getFromCache()
 	 */
-	function matching($cc)	{
+	function matching($cc) {
-		if (is_array($cc['all']))	{
+		if (is_array($cc['all'])) {
 			/* @var $matchObj t3lib_matchCondition_frontend */
 			$matchObj = t3lib_div::makeInstance('t3lib_matchCondition_frontend');
-			$matchObj->setRootline((array)$cc['rootLine']);
+			$matchObj->setRootline((array) $cc['rootLine']);
 			foreach ($cc['all'] as $key => $pre) {
-				if ($matchObj->match($pre))	{
+				if ($matchObj->match($pre)) {
-					$sectionsMatch[$key]=$pre;
+					$sectionsMatch[$key] = $pre;
 				}
 			}
-			$cc['match']=$sectionsMatch;
+			$cc['match'] = $sectionsMatch;
 		}
 		return $cc;
 	}
@@ -316,7 +299,7 @@
 	 * @return	void
 	 * @see tslib_fe::getConfigArray()
 	 */
-	function start($theRootLine)	{
+	function start($theRootLine) {
 		if (is_array($theRootLine)) {
 			$setupData = '';
 			$hash = '';
@@ -325,7 +308,7 @@
 				// could be used (this is the case if $TSFE->all is set, and the
 				// rowSum still matches). Based on this we decide if cache_pagesection
 				// needs to be updated...
-			$isCached = false;
+			$isCached = FALSE;
 
 			$this->runThroughTemplates($theRootLine);
 
@@ -333,12 +316,12 @@
 				$cc = $GLOBALS['TSFE']->all;
 
 					// The two rowSums must NOT be different from each other - which they will be if start/endtime or hidden has changed!
-				if (strcmp(serialize($this->rowSum),serialize($cc['rowSum']))) {
+				if (strcmp(serialize($this->rowSum), serialize($cc['rowSum']))) {
-					unset($cc);	// If the two rowSums differ, we need to re-make the current page data and therefore clear the existing values.
+					unset($cc); // If the two rowSums differ, we need to re-make the current page data and therefore clear the existing values.
 				} else {
 						// If $TSFE->all contains valid data, we don't need to update cache_pagesection (because this data was fetched from there already)
 					if (!strcmp(serialize($this->rootLine), serialize($cc['rootLine']))) {
-						$isCached = true;
+						$isCached = TRUE;
 					}
 						// When the data is serialized below (ROWSUM hash), it must not contain the rootline by concept. So this must be removed (and added again later)...
 					unset($cc['rootLine']);
@@ -357,7 +340,7 @@
 				$hash = md5(serialize($cc));
 			} else {
 					// If currentPageData was not there, we first find $rowSum (freshly generated). After that we try to see, if it is stored with a list of all conditions. If so we match the result.
-				$rowSumHash = md5('ROWSUM:'.serialize($this->rowSum));
+				$rowSumHash = md5('ROWSUM:' . serialize($this->rowSum));
 				$result = t3lib_pageSelect::getHash($rowSumHash);
 
 				if ($result) {
@@ -384,8 +367,8 @@
 
 					// This stores the template hash thing
 				$cc = array();
-				$cc['all'] = $this->sections;	// All sections in the template at this point is found
+				$cc['all'] = $this->sections; // All sections in the template at this point is found
-				$cc['rowSum'] = $this->rowSum;	// The line of templates is collected
+				$cc['rowSum'] = $this->rowSum; // The line of templates is collected
 				$cc = $this->matching($cc);
 				ksort($cc);
 
@@ -394,9 +377,11 @@
 					// This stores the data.
 				t3lib_pageSelect::storeHash($hash, serialize($this->setup), 'TS_TEMPLATE');
 
-				if ($this->tt_track)	$GLOBALS['TT']->setTSlogMessage('TS template size, serialized: '.strlen(serialize($this->setup)).' bytes');
+				if ($this->tt_track) {
+					$GLOBALS['TT']->setTSlogMessage('TS template size, serialized: ' . strlen(serialize($this->setup)) . ' bytes');
+				}
 
-				$rowSumHash = md5('ROWSUM:'.serialize($this->rowSum));
+				$rowSumHash = md5('ROWSUM:' . serialize($this->rowSum));
 				t3lib_pageSelect::storeHash($rowSumHash, serialize($cc['all']), 'TMPL_CONDITIONS_ALL');
 			}
 				// Add rootLine
@@ -409,7 +394,7 @@
 				// Matching must be executed for every request, so this must never be part of the pagesection cache!
 			unset($cc['match']);
 
-			if (!$isCached && !$this->simulationHiddenOrTime && !$GLOBALS['TSFE']->no_cache) {	// Only save the data if we're not simulating by hidden/starttime/endtime
+			if (!$isCached && !$this->simulationHiddenOrTime && !$GLOBALS['TSFE']->no_cache) { // Only save the data if we're not simulating by hidden/starttime/endtime
 				$mpvarHash = t3lib_div::md5int($GLOBALS['TSFE']->MP);
 				if (TYPO3_UseCachingFramework) {
 					$pageSectionCache = $GLOBALS['typo3CacheManager']->getCache('cache_pagesection');
@@ -418,8 +403,8 @@
 						intval($GLOBALS['TSFE']->id) . '_' . $mpvarHash,
 						serialize($cc),
 						array(
-							'pageId_' . intval($GLOBALS['TSFE']->id),
-							'mpvarHash_' . $mpvarHash
+							 'pageId_' . intval($GLOBALS['TSFE']->id),
+							 'mpvarHash_' . $mpvarHash
 						)
 					);
 				} else {
@@ -436,26 +421,13 @@
 				}
 			}
 				// If everything OK.
-			if ($this->rootId && $this->rootLine && $this->setup)	{
+			if ($this->rootId && $this->rootLine && $this->setup) {
 				$this->loaded = 1;
 			}
 		}
 	}
 
 
-
-
-
-
-
-
-
-
-
-
-
-
-
 	/*******************************************************************
 	 *
 	 * Fetching TypoScript code text for the Template Hierarchy
@@ -472,40 +444,40 @@
 	 * @return	void
 	 * @see start()
 	 */
-	function runThroughTemplates($theRootLine,$start_template_uid=0)	{
+	function runThroughTemplates($theRootLine, $start_template_uid = 0) {
-		$this->constants = Array();
-		$this->config = Array();
-		$this->editorcfg = Array();
-		$this->rowSum = Array();
-		$this->hierarchyInfoToRoot = Array();
+		$this->constants = array();
+		$this->config = array();
+		$this->editorcfg = array();
+		$this->rowSum = array();
+		$this->hierarchyInfoToRoot = array();
-		$this->absoluteRootLine=$theRootLine;	// Is the TOTAL rootline
+		$this->absoluteRootLine = $theRootLine; // Is the TOTAL rootline
 
-		reset ($this->absoluteRootLine);
+		reset($this->absoluteRootLine);
-		$c=count($this->absoluteRootLine);
+		$c = count($this->absoluteRootLine);
-		for ($a=0;$a<$c;$a++)	{
+		for ($a = 0; $a < $c; $a++) {
-			if ($this->nextLevel)	{	// If some template loaded before has set a template-id for the next level, then load this template first!
+			if ($this->nextLevel) { // If some template loaded before has set a template-id for the next level, then load this template first!
-				$res = $GLOBALS['TYPO3_DB']->exec_SELECTquery('*', 'sys_template', 'uid='.intval($this->nextLevel).' '.$this->whereClause);
+				$res = $GLOBALS['TYPO3_DB']->exec_SELECTquery('*', 'sys_template', 'uid=' . intval($this->nextLevel) . ' ' . $this->whereClause);
 				$this->nextLevel = 0;
-				if ($row = $GLOBALS['TYPO3_DB']->sql_fetch_assoc($res))	{
+				if ($row = $GLOBALS['TYPO3_DB']->sql_fetch_assoc($res)) {
 					$this->versionOL($row);
-					if (is_array($row))	{
+					if (is_array($row)) {
-						$this->processTemplate($row,'sys_'.$row['uid'],$this->absoluteRootLine[$a]['uid'],'sys_'.$row['uid']);
+						$this->processTemplate($row, 'sys_' . $row['uid'], $this->absoluteRootLine[$a]['uid'], 'sys_' . $row['uid']);
-						$this->outermostRootlineIndexWithTemplate=$a;
+						$this->outermostRootlineIndexWithTemplate = $a;
 					}
 				}
 				$GLOBALS['TYPO3_DB']->sql_free_result($res);
 			}
-			$addC='';
+			$addC = '';
-			if ($a==($c-1) && $start_template_uid)	{	// If first loop AND there is set an alternative template uid, use that
+			if ($a == ($c - 1) && $start_template_uid) { // If first loop AND there is set an alternative template uid, use that
-				$addC=' AND uid='.intval($start_template_uid);
+				$addC = ' AND uid=' . intval($start_template_uid);
 			}
 
-			$res = $GLOBALS['TYPO3_DB']->exec_SELECTquery('*', 'sys_template', 'pid='.intval($this->absoluteRootLine[$a]['uid']).$addC.' '.$this->whereClause,'','sorting',1);
+			$res = $GLOBALS['TYPO3_DB']->exec_SELECTquery('*', 'sys_template', 'pid=' . intval($this->absoluteRootLine[$a]['uid']) . $addC . ' ' . $this->whereClause, '', 'sorting', 1);
-			if ($row = $GLOBALS['TYPO3_DB']->sql_fetch_assoc($res))	{
+			if ($row = $GLOBALS['TYPO3_DB']->sql_fetch_assoc($res)) {
 				$this->versionOL($row);
-				if (is_array($row))	{
+				if (is_array($row)) {
-					$this->processTemplate($row,'sys_'.$row['uid'],$this->absoluteRootLine[$a]['uid'],'sys_'.$row['uid']);
+					$this->processTemplate($row, 'sys_' . $row['uid'], $this->absoluteRootLine[$a]['uid'], 'sys_' . $row['uid']);
-					$this->outermostRootlineIndexWithTemplate=$a;
+					$this->outermostRootlineIndexWithTemplate = $a;
 				}
 			}
 			$GLOBALS['TYPO3_DB']->sql_free_result($res);
@@ -526,48 +498,48 @@
 	 * @return	void
 	 * @see runThroughTemplates()
 	 */
-	function processTemplate($row, $idList,$pid,$templateID='',$templateParent='')	{
+	function processTemplate($row, $idList, $pid, $templateID = '', $templateParent = '') {
 			// Adding basic template record information to rowSum array
-		$this->rowSum[]=Array($row['uid'],$row['title'],$row['tstamp']);
+		$this->rowSum[] = array($row['uid'], $row['title'], $row['tstamp']);
 
 			// Processing "Clear"-flags
-		if ($row['clear'])	{
+		if ($row['clear']) {
-			$clConst = $row['clear']&1;
+			$clConst = $row['clear'] & 1;
-			$clConf = $row['clear']&2;
+			$clConf = $row['clear'] & 2;
-			if ($clConst)	{
+			if ($clConst) {
-				$this->constants = Array();
+				$this->constants = array();
-				$this->clearList_const=array();
+				$this->clearList_const = array();
 			}
-			if ($clConf)	{
+			if ($clConf) {
-				$this->config = Array();
-				$this->hierarchyInfoToRoot = Array();
+				$this->config = array();
+				$this->hierarchyInfoToRoot = array();
-				$this->clearList_setup=array();
+				$this->clearList_setup = array();
 
-				$this->editorcfg = Array();
+				$this->editorcfg = array();
-				$this->clearList_editorcfg=array();
+				$this->clearList_editorcfg = array();
 			}
 		}
 
 			// Include static records (static_template) or files (from extensions) (#1/2)
 			// NORMAL inclusion, The EXACT same code is found below the basedOn inclusion!!!
-		if (!$row['includeStaticAfterBasedOn'])		{
+		if (!$row['includeStaticAfterBasedOn']) {
-			$this->includeStaticTypoScriptSources($idList,$templateID,$pid,$row);
+			$this->includeStaticTypoScriptSources($idList, $templateID, $pid, $row);
 		}
 
 			// Include "Based On" sys_templates:
-		if (trim($row['basedOn']))	{		// 'basedOn' is a list of templates to include
+		if (trim($row['basedOn'])) { // 'basedOn' is a list of templates to include
 				// Manually you can put this value in the field and then the based_on ID will be taken from the $_GET var defined by '=....'.
 				// Example: If $row['basedOn'] is 'EXTERNAL_BASED_ON_TEMPLATE_ID=based_on_uid', then the global var, based_on_uid - given by the URL like '&based_on_uid=999' - is included instead!
 				// This feature allows us a hack to test/demonstrate various included templates on the same set of content bearing pages. Used by the "freesite" extension.
-			$basedOn_hackFeature = explode('=',$row['basedOn']);
+			$basedOn_hackFeature = explode('=', $row['basedOn']);
-			if ($basedOn_hackFeature[0]=='EXTERNAL_BASED_ON_TEMPLATE_ID' && $basedOn_hackFeature[1])		{
+			if ($basedOn_hackFeature[0] == 'EXTERNAL_BASED_ON_TEMPLATE_ID' && $basedOn_hackFeature[1]) {
 				$id = intval(t3lib_div::_GET($basedOn_hackFeature[1]));
-				if ($id && !t3lib_div::inList($idList,'sys_'.$id))	{	// if $id is not allready included ...
+				if ($id && !t3lib_div::inList($idList, 'sys_' . $id)) { // if $id is not allready included ...
-					$res = $GLOBALS['TYPO3_DB']->exec_SELECTquery('*', 'sys_template', 'uid='.$id.' '.$this->whereClause);
+					$res = $GLOBALS['TYPO3_DB']->exec_SELECTquery('*', 'sys_template', 'uid=' . $id . ' ' . $this->whereClause);
-					if ($subrow = $GLOBALS['TYPO3_DB']->sql_fetch_assoc($res))	{	// there was a template, then we fetch that
+					if ($subrow = $GLOBALS['TYPO3_DB']->sql_fetch_assoc($res)) { // there was a template, then we fetch that
 						$this->versionOL($subrow);
-						if (is_array($subrow))	{
+						if (is_array($subrow)) {
-							$this->processTemplate($subrow,$idList.',sys_'.$id,$pid, 'sys_'.$id,$templateID);
+							$this->processTemplate($subrow, $idList . ',sys_' . $id, $pid, 'sys_' . $id, $templateID);
 						}
 					}
 					$GLOBALS['TYPO3_DB']->sql_free_result($res);
@@ -588,7 +560,7 @@
 					'*', 'sys_template',
 					'uid IN (' . implode(',', $basedOnIds) . ') ' . $this->whereClause,
 					'', '', '',
-					'uid'	// the associative array that is returned will contain this field as key
+					'uid' // the associative array that is returned will contain this field as key
 				);
 
 					// traversing list again to ensure the sorting of the templates
@@ -602,48 +574,52 @@
 		}
 
 			// Include static records (static_template) or files (from extensions) (#2/2)
-		if ($row['includeStaticAfterBasedOn'])		{
+		if ($row['includeStaticAfterBasedOn']) {
-			$this->includeStaticTypoScriptSources($idList,$templateID,$pid,$row);
+			$this->includeStaticTypoScriptSources($idList, $templateID, $pid, $row);
 		}
 
 			// Creating hierarchy information; Used by backend analysis tools
 		$this->hierarchyInfo[] = $this->hierarchyInfoToRoot[] = array(
-			'root'=>trim($row['root']),
+			'root' => trim($row['root']),
-			'next'=>$row['nextLevel'],
+			'next' => $row['nextLevel'],
-			'clConst'=>$clConst,
+			'clConst' => $clConst,
-			'clConf'=>$clConf,
+			'clConf' => $clConf,
-			'templateID'=>$templateID,
+			'templateID' => $templateID,
-			'templateParent'=>$templateParent,
+			'templateParent' => $templateParent,
-			'title'=>$row['title'],
+			'title' => $row['title'],
-			'uid'=>$row['uid'],
+			'uid' => $row['uid'],
-			'pid'=>$row['pid'],
+			'pid' => $row['pid'],
-			'configLines' => substr_count($row['config'], LF)+1
+			'configLines' => substr_count($row['config'], LF) + 1
 		);
 
 			// Adding the content of the fields constants (Constants), config (Setup) and editorcfg (Backend Editor Configuration) to the internal arrays.
 		$this->constants[] = $row['constants'];
 		$this->config[] = $row['config'];
-		if ($this->parseEditorCfgField)		$this->editorcfg[] = $row['editorcfg'];
+		if ($this->parseEditorCfgField) {
+			$this->editorcfg[] = $row['editorcfg'];
+		}
 
 			// For backend analysis (Template Analyser) provide the order of added constants/config/editorcfg template IDs
-		$this->clearList_const[]=$templateID;
+		$this->clearList_const[] = $templateID;
-		$this->clearList_setup[]=$templateID;
+		$this->clearList_setup[] = $templateID;
-		if ($this->parseEditorCfgField)		$this->clearList_editorcfg[]=$templateID;
+		if ($this->parseEditorCfgField) {
+			$this->clearList_editorcfg[] = $templateID;
+		}
 
 			// Add resources and sitetitle if found:
-		if (trim($row['resources']))	{
+		if (trim($row['resources'])) {
-			$this->resources = $row['resources'].','.$this->resources;
+			$this->resources = $row['resources'] . ',' . $this->resources;
 		}
-		if (trim($row['sitetitle']))	{
+		if (trim($row['sitetitle'])) {
 			$this->sitetitle = $row['sitetitle'];
 		}
 			// If the template record is a Rootlevel record, set the flag and clear the template rootLine (so it starts over from this point)
-		if (trim($row['root']))	{
+		if (trim($row['root'])) {
 			$this->rootId = $pid;
-			$this->rootLine = Array();
+			$this->rootLine = array();
 		}
 			// If a template is set to be active on the next level set this internal value to point to this UID. (See runThroughTemplates())
-		if ($row['nextLevel'])	{
+		if ($row['nextLevel']) {
 			$this->nextLevel = $row['nextLevel'];
 		} else {
 			$this->nextLevel = 0;
@@ -660,61 +636,61 @@
 	 * @return	void
 	 * @see processTemplate()
 	 */
-	function includeStaticTypoScriptSources($idList,$templateID,$pid,$row)	{
+	function includeStaticTypoScriptSources($idList, $templateID, $pid, $row) {
 			// Static Template Records (static_template): include_static is a list of static templates to include
 			// Call function for link rendering:
 		if (is_array($GLOBALS['TYPO3_CONF_VARS']['SC_OPTIONS']['t3lib/class.t3lib_tstemplate.php']['includeStaticTypoScriptSources'])) {
 			$_params = array(
-					'idList' => &$idList,
-					'templateId' => &$templateID,
-					'pid' => &$pid,
-					'row' => &$row
+				'idList' => &$idList,
+				'templateId' => &$templateID,
+				'pid' => &$pid,
+				'row' => &$row
 			);
-			foreach ($GLOBALS['TYPO3_CONF_VARS']['SC_OPTIONS']['t3lib/class.t3lib_tstemplate.php']['includeStaticTypoScriptSources'] as $_funcRef)	{
+			foreach ($GLOBALS['TYPO3_CONF_VARS']['SC_OPTIONS']['t3lib/class.t3lib_tstemplate.php']['includeStaticTypoScriptSources'] as $_funcRef) {
 				t3lib_div::callUserFunction($_funcRef, $_params, $this);
 			}
 		}
 
 			// Static Template Files (Text files from extensions): include_static_file is a list of static files to include (from extensions)
-		if (trim($row['include_static_file']))	{
+		if (trim($row['include_static_file'])) {
-			$include_static_fileArr = t3lib_div::trimExplode(',', $row['include_static_file'], true);
+			$include_static_fileArr = t3lib_div::trimExplode(',', $row['include_static_file'], TRUE);
 			foreach ($include_static_fileArr as $ISF_file) { // traversing list
-				if (substr($ISF_file,0,4)=='EXT:')	{
+				if (substr($ISF_file, 0, 4) == 'EXT:') {
-					list($ISF_extKey,$ISF_localPath) = explode('/',substr($ISF_file,4),2);
+					list($ISF_extKey, $ISF_localPath) = explode('/', substr($ISF_file, 4), 2);
-					if (strcmp($ISF_extKey,'') && t3lib_extMgm::isLoaded($ISF_extKey) && strcmp($ISF_localPath,''))	{
+					if (strcmp($ISF_extKey, '') && t3lib_extMgm::isLoaded($ISF_extKey) && strcmp($ISF_localPath, '')) {
-						$ISF_localPath = rtrim($ISF_localPath, '/').'/';
+						$ISF_localPath = rtrim($ISF_localPath, '/') . '/';
-						$ISF_filePath = t3lib_extMgm::extPath($ISF_extKey).$ISF_localPath;
+						$ISF_filePath = t3lib_extMgm::extPath($ISF_extKey) . $ISF_localPath;
-						if (@is_dir($ISF_filePath))	{
+						if (@is_dir($ISF_filePath)) {
-							$mExtKey = str_replace('_','',$ISF_extKey.'/'.$ISF_localPath);
+							$mExtKey = str_replace('_', '', $ISF_extKey . '/' . $ISF_localPath);
-							$subrow=array(
+							$subrow = array(
-								'constants'=>	@is_file($ISF_filePath.'constants.txt')	?t3lib_div::getUrl($ISF_filePath.'constants.txt'):'',
+								'constants' => @is_file($ISF_filePath . 'constants.txt') ? t3lib_div::getUrl($ISF_filePath . 'constants.txt') : '',
-								'config'=>		@is_file($ISF_filePath.'setup.txt')		?t3lib_div::getUrl($ISF_filePath.'setup.txt'):'',
+								'config' => @is_file($ISF_filePath . 'setup.txt') ? t3lib_div::getUrl($ISF_filePath . 'setup.txt') : '',
-								'editorcfg'=>	@is_file($ISF_filePath.'editorcfg.txt')	?t3lib_div::getUrl($ISF_filePath.'editorcfg.txt'):'',
+								'editorcfg' => @is_file($ISF_filePath . 'editorcfg.txt') ? t3lib_div::getUrl($ISF_filePath . 'editorcfg.txt') : '',
-								'include_static'=>	@is_file($ISF_filePath.'include_static.txt')?implode(',',array_unique(t3lib_div::intExplode(',',t3lib_div::getUrl($ISF_filePath.'include_static.txt')))):'',
+								'include_static' => @is_file($ISF_filePath . 'include_static.txt') ? implode(',', array_unique(t3lib_div::intExplode(',', t3lib_div::getUrl($ISF_filePath . 'include_static.txt')))) : '',
-								'include_static_file'=>	@is_file($ISF_filePath.'include_static_file.txt')?implode(',',array_unique(explode(',',t3lib_div::getUrl($ISF_filePath.'include_static_file.txt')))):'',
+								'include_static_file' => @is_file($ISF_filePath . 'include_static_file.txt') ? implode(',', array_unique(explode(',', t3lib_div::getUrl($ISF_filePath . 'include_static_file.txt')))) : '',
-								'title' => 		$ISF_file,
+								'title' => $ISF_file,
-								'uid' => 		$mExtKey
+								'uid' => $mExtKey
 							);
 							$subrow = $this->prependStaticExtra($subrow);
 
-							$this->processTemplate($subrow,$idList.',ext_'.$mExtKey,$pid, 'ext_'.$mExtKey,$templateID);
+							$this->processTemplate($subrow, $idList . ',ext_' . $mExtKey, $pid, 'ext_' . $mExtKey, $templateID);
 						}
 					}
 				}
 			}
 		}
 
-		$this->addExtensionStatics($idList,$templateID,$pid,$row);
+		$this->addExtensionStatics($idList, $templateID, $pid, $row);
 
 			// Include Static Template Records after all other TypoScript has been included.
 		if (is_array($GLOBALS['TYPO3_CONF_VARS']['SC_OPTIONS']['t3lib/class.t3lib_tstemplate.php']['includeStaticTypoScriptSourcesAtEnd'])) {
 			$_params = array(
-					'idList' => &$idList,
-					'templateId' => &$templateID,
-					'pid' => &$pid,
-					'row' => &$row
+				'idList' => &$idList,
+				'templateId' => &$templateID,
+				'pid' => &$pid,
+				'row' => &$row
 			);
-			foreach ($GLOBALS['TYPO3_CONF_VARS']['SC_OPTIONS']['t3lib/class.t3lib_tstemplate.php']['includeStaticTypoScriptSourcesAtEnd'] as $_funcRef)	{
+			foreach ($GLOBALS['TYPO3_CONF_VARS']['SC_OPTIONS']['t3lib/class.t3lib_tstemplate.php']['includeStaticTypoScriptSourcesAtEnd'] as $_funcRef) {
 				t3lib_div::callUserFunction($_funcRef, $_params, $this);
 			}
 		}
@@ -731,23 +707,23 @@
 	 * @access private
 	 * @see includeStaticTypoScriptSources()
 	 */
-	function addExtensionStatics($idList,$templateID,$pid,$row) {
+	function addExtensionStatics($idList, $templateID, $pid, $row) {
 		global $TYPO3_LOADED_EXT;
 
-		if ($row['static_file_mode']==1 || ($row['static_file_mode']==0 && substr($templateID,0,4)=='sys_' && $row['root']))	{
+		if ($row['static_file_mode'] == 1 || ($row['static_file_mode'] == 0 && substr($templateID, 0, 4) == 'sys_' && $row['root'])) {
 			foreach ($TYPO3_LOADED_EXT as $extKey => $files) {
-				if (is_array($files) && ($files['ext_typoscript_constants.txt'] || $files['ext_typoscript_setup.txt'] || $files['ext_typoscript_editorcfg.txt']))	{
+				if (is_array($files) && ($files['ext_typoscript_constants.txt'] || $files['ext_typoscript_setup.txt'] || $files['ext_typoscript_editorcfg.txt'])) {
-					$mExtKey = str_replace('_','',$extKey);
+					$mExtKey = str_replace('_', '', $extKey);
-					$subrow=array(
+					$subrow = array(
-						'constants'=>	$files['ext_typoscript_constants.txt']?t3lib_div::getUrl($files['ext_typoscript_constants.txt']):'',
+						'constants' => $files['ext_typoscript_constants.txt'] ? t3lib_div::getUrl($files['ext_typoscript_constants.txt']) : '',
-						'config'=>		$files['ext_typoscript_setup.txt']?t3lib_div::getUrl($files['ext_typoscript_setup.txt']):'',
+						'config' => $files['ext_typoscript_setup.txt'] ? t3lib_div::getUrl($files['ext_typoscript_setup.txt']) : '',
-						'editorcfg'=>		$files['ext_typoscript_editorcfg.txt']?t3lib_div::getUrl($files['ext_typoscript_editorcfg.txt']):'',
+						'editorcfg' => $files['ext_typoscript_editorcfg.txt'] ? t3lib_div::getUrl($files['ext_typoscript_editorcfg.txt']) : '',
-						'title' => 		$extKey,
+						'title' => $extKey,
-						'uid' => 		$mExtKey
+						'uid' => $mExtKey
 					);
 					$subrow = $this->prependStaticExtra($subrow);
 
-					$this->processTemplate($subrow,$idList.',ext_'.$mExtKey,$pid, 'ext_'.$mExtKey,$templateID);
+					$this->processTemplate($subrow, $idList . ',ext_' . $mExtKey, $pid, 'ext_' . $mExtKey, $templateID);
 				}
 			}
 		}
@@ -763,10 +739,10 @@
 	 * @access private
 	 * @see addExtensionStatics(), includeStaticTypoScriptSources()
 	 */
-	function prependStaticExtra($subrow)	{
+	function prependStaticExtra($subrow) {
-		$subrow['config'].=$GLOBALS['TYPO3_CONF_VARS']['FE']['defaultTypoScript_setup.'][$subrow['uid']];
+		$subrow['config'] .= $GLOBALS['TYPO3_CONF_VARS']['FE']['defaultTypoScript_setup.'][$subrow['uid']];
-		$subrow['editorcfg'].=$GLOBALS['TYPO3_CONF_VARS']['FE']['defaultTypoScript_editorcfg.'][$subrow['uid']];
+		$subrow['editorcfg'] .= $GLOBALS['TYPO3_CONF_VARS']['FE']['defaultTypoScript_editorcfg.'][$subrow['uid']];
-		$subrow['constants'].=$GLOBALS['TYPO3_CONF_VARS']['FE']['defaultTypoScript_constants.'][$subrow['uid']];
+		$subrow['constants'] .= $GLOBALS['TYPO3_CONF_VARS']['FE']['defaultTypoScript_constants.'][$subrow['uid']];
 		return $subrow;
 	}
 
@@ -776,30 +752,15 @@
 	 * @param	array		Row to overlay.
 	 * @return	void		Row is passed by reference.
 	 */
-	function versionOL(&$row)	{
+	function versionOL(&$row) {
-		if (is_object($GLOBALS['TSFE']))	{	// Frontend:
+		if (is_object($GLOBALS['TSFE'])) { // Frontend:
-			$GLOBALS['TSFE']->sys_page->versionOL('sys_template',$row);
+			$GLOBALS['TSFE']->sys_page->versionOL('sys_template', $row);
-		} else {	// Backend:
+		} else { // Backend:
-			t3lib_BEfunc::workspaceOL('sys_template',$row);
+			t3lib_BEfunc::workspaceOL('sys_template', $row);
 		}
 	}
 
 
-
-
-
-
-
-
-
-
-
-
-
-
-
-
-
 	/*******************************************************************
 	 *
 	 * Parsing TypoScript code text from Template Records into PHP array
@@ -813,53 +774,51 @@
 	 * @return	void
 	 * @see t3lib_TSparser, start()
 	 */
-	function generateConfig()	{
+	function generateConfig() {
 			// Add default TS for all three code types:
-		array_unshift($this->constants,''.$GLOBALS['TYPO3_CONF_VARS']['FE']['defaultTypoScript_constants']);	// Adding default TS/constants
+		array_unshift($this->constants, '' . $GLOBALS['TYPO3_CONF_VARS']['FE']['defaultTypoScript_constants']); // Adding default TS/constants
-		array_unshift($this->config,''.$GLOBALS['TYPO3_CONF_VARS']['FE']['defaultTypoScript_setup']);	// Adding default TS/setup
+		array_unshift($this->config, '' . $GLOBALS['TYPO3_CONF_VARS']['FE']['defaultTypoScript_setup']); // Adding default TS/setup
-		array_unshift($this->editorcfg,''.$GLOBALS['TYPO3_CONF_VARS']['FE']['defaultTypoScript_editorcfg']);	// Adding default TS/editorcfg
+		array_unshift($this->editorcfg, '' . $GLOBALS['TYPO3_CONF_VARS']['FE']['defaultTypoScript_editorcfg']); // Adding default TS/editorcfg
 
 			// Parse the TypoScript code text for include-instructions!
 		$this->processIncludes();
 
 			// These vars are also set lateron...
-		$this->setup['resources']= $this->resources;
+		$this->setup['resources'] = $this->resources;
-		$this->setup['sitetitle']= $this->sitetitle;
+		$this->setup['sitetitle'] = $this->sitetitle;
 
 
-
-		// ****************************
-		// Parse TypoScript Constants
-		// ****************************
+			// ****************************
+			// Parse TypoScript Constants
+			// ****************************
 
 			// Initialize parser and match-condition classes:
 		$constants = t3lib_div::makeInstance('t3lib_TSparser');
-		$constants->breakPointLN=intval($this->ext_constants_BRP);
+		$constants->breakPointLN = intval($this->ext_constants_BRP);
 		$constants->setup = $this->const;
 		$constants->setup = $this->mergeConstantsFromPageTSconfig($constants->setup);
 
 		/* @var $matchObj t3lib_matchCondition_frontend */
 		$matchObj = t3lib_div::makeInstance('t3lib_matchCondition_frontend');
 		$matchObj->setSimulateMatchConditions($this->matchAlternative);
-		$matchObj->setSimulateMatchResult((bool)$this->matchAll);
+		$matchObj->setSimulateMatchResult((bool) $this->matchAll);
 
 			// Traverse constants text fields and parse them
-		foreach($this->constants as $str)	{
+		foreach ($this->constants as $str) {
-			$constants->parse($str,$matchObj);
+			$constants->parse($str, $matchObj);
 		}
 
 			// Read out parse errors if any
-		$this->parserErrors['constants']=$constants->errors;
+		$this->parserErrors['constants'] = $constants->errors;
 
 			// Then flatten the structure from a multi-dim array to a single dim array with all constants listed as key/value pairs (ready for substitution)
-		$this->flatSetup = Array();
+		$this->flatSetup = array();
-		$this->flattenSetup($constants->setup,'','');
+		$this->flattenSetup($constants->setup, '', '');
 
 
-
-		// ***********************************************
-		// Parse TypoScript Setup (here called "config")
-		// ***********************************************
+			// ***********************************************
+			// Parse TypoScript Setup (here called "config")
+			// ***********************************************
 			// Initialize parser and match-condition classes:
 		$config = t3lib_div::makeInstance('t3lib_TSparser');
 		$config->breakPointLN = intval($this->ext_config_BRP);
@@ -872,96 +831,99 @@
 		$config->sectionsMatch = $constants->sectionsMatch;
 
 			// Traverse setup text fields and concatenate them into one, single string separated by a [GLOBAL] condition
-		$all='';
+		$all = '';
-		foreach($this->config as $str)	{
+		foreach ($this->config as $str) {
-			$all.="\n[GLOBAL]\n".$str;
+			$all .= "\n[GLOBAL]\n" . $str;
 		}
 
 			// Substitute constants in the Setup code:
-		if ($this->tt_track)	$GLOBALS['TT']->push('Substitute Constants ('.count($this->flatSetup).')');
+		if ($this->tt_track) {
+			$GLOBALS['TT']->push('Substitute Constants (' . count($this->flatSetup) . ')');
+		}
 		$all = $this->substituteConstants($all);
-		if ($this->tt_track)	$GLOBALS['TT']->pull();
+		if ($this->tt_track) {
+			$GLOBALS['TT']->pull();
+		}
 
 			// Searching for possible unsubstituted constants left (only for information)
-		if (strstr($all,'{$'))	{
+		if (strstr($all, '{$')) {
 			$theConstList = array();
 			$findConst = explode('{$', $all);
 			array_shift($findConst);
 			foreach ($findConst as $constVal) {
-				$constLen=t3lib_div::intInRange(strcspn($constVal,'}'),0,50);
+				$constLen = t3lib_div::intInRange(strcspn($constVal, '}'), 0, 50);
-				$theConstList[]='{$'.substr($constVal,0,$constLen+1);
+				$theConstList[] = '{$' . substr($constVal, 0, $constLen + 1);
 			}
-			if ($this->tt_track)	$GLOBALS['TT']->setTSlogMessage(implode(', ',$theConstList).': Constants may remain un-substituted!!',2);
+			if ($this->tt_track) {
+				$GLOBALS['TT']->setTSlogMessage(implode(', ', $theConstList) . ': Constants may remain un-substituted!!', 2);
-		}
+			}
+		}
 
 			// Logging the textual size of the TypoScript Setup field text with all constants substituted:
-		if ($this->tt_track)	$GLOBALS['TT']->setTSlogMessage('TypoScript template size as textfile: '.strlen($all).' bytes');
+		if ($this->tt_track) {
+			$GLOBALS['TT']->setTSlogMessage('TypoScript template size as textfile: ' . strlen($all) . ' bytes');
+		}
 
 			// Finally parse the Setup field TypoScript code (where constants are now substituted)
-		$config->parse($all,$matchObj);
+		$config->parse($all, $matchObj);
 
 			// Read out parse errors if any
-		$this->parserErrors['config']=$config->errors;
+		$this->parserErrors['config'] = $config->errors;
 
 			// Transfer the TypoScript array from the parser object to the internal $this->setup array:
 		$this->setup = $config->setup;
-		if ($this->backend_info)	{
+		if ($this->backend_info) {
-			$this->setup_constants = $constants->setup;		// Used for backend purposes only
+			$this->setup_constants = $constants->setup; // Used for backend purposes only
 		}
 
 
-
-
-		// **************************************************
-		// Parse Backend Editor Configuration (backend only)
-		// **************************************************
+			// **************************************************
+			// Parse Backend Editor Configuration (backend only)
+			// **************************************************
-		if ($this->parseEditorCfgField)	{
+		if ($this->parseEditorCfgField) {
 			$editorcfg = t3lib_div::makeInstance('t3lib_TSparser');
-			$editorcfg->breakPointLN=intval($this->ext_editorcfg_BRP);
+			$editorcfg->breakPointLN = intval($this->ext_editorcfg_BRP);
-			$editorcfg->setup = array();	// Empty as a start...
+			$editorcfg->setup = array(); // Empty as a start...
 
-			$all = implode("\n[GLOBAL]\n",$this->editorcfg);
+			$all = implode("\n[GLOBAL]\n", $this->editorcfg);
 
 				// substitute constants in config
 			$all = $this->substituteConstants($all);
 
 				// parse Config
-			$matchObj->matchAll=1;	// This should make sure that conditions are disabled. For now they are NOT active for the backend.
+			$matchObj->matchAll = 1; // This should make sure that conditions are disabled. For now they are NOT active for the backend.
-			$editorcfg->parse($all,$matchObj);
+			$editorcfg->parse($all, $matchObj);
-			$this->parserErrors['editorcfg']=$editorcfg->errors;
+			$this->parserErrors['editorcfg'] = $editorcfg->errors;
 			$this->setup_editorcfg = $editorcfg->setup;
 		}
 
 
-
-
-
-		// ****************************************************************
-		// Final processing of the $this->setup TypoScript Template array
-		// Basically: This is unsetting/setting of certain reserved keys.
-		// ****************************************************************
+			// ****************************************************************
+			// Final processing of the $this->setup TypoScript Template array
+			// Basically: This is unsetting/setting of certain reserved keys.
+			// ****************************************************************
 
 			// These vars are allready set after 'processTemplate', but because $config->setup overrides them (in the line above!), we set them again. They are not changed compared to the value they had in the top of the page!
 		unset($this->setup['resources']);
 		unset($this->setup['resources.']);
-		$this->setup['resources']= implode(',',t3lib_div::trimExplode(',',$this->resources,1));
+		$this->setup['resources'] = implode(',', t3lib_div::trimExplode(',', $this->resources, 1));
 
 		unset($this->setup['sitetitle']);
 		unset($this->setup['sitetitle.']);
-		$this->setup['sitetitle']= $this->sitetitle;
+		$this->setup['sitetitle'] = $this->sitetitle;
 
 			// Unsetting some vars...
 		unset($this->setup['types.']);
 		unset($this->setup['types']);
 		if (is_array($this->setup)) {
 			foreach ($this->setup as $key => $value) {
-				if ($value=='PAGE')	{
+				if ($value == 'PAGE') {
 						// Set the typeNum of the current page object:
-					if (isset($this->setup[$key.'.']['typeNum'])) {
+					if (isset($this->setup[$key . '.']['typeNum'])) {
-						$typeNum = $this->setup[$key.'.']['typeNum'];
+						$typeNum = $this->setup[$key . '.']['typeNum'];
 						$this->setup['types.'][$typeNum] = $key;
 						// If there is no type 0 yet and typeNum was not set, we use the current object as the default
-					} elseif(!isset($this->setup['types.'][0]) || !$this->setup['types.'][0]) {
+					} elseif (!isset($this->setup['types.'][0]) || !$this->setup['types.'][0]) {
 						$this->setup['types.'][0] = $key;
 					}
 				}
@@ -999,19 +961,19 @@
 	public function processIncludes() {
 		$files = array();
 		foreach ($this->constants as &$value) {
-			$includeData = t3lib_TSparser::checkIncludeLines($value, 1, true);
+			$includeData = t3lib_TSparser::checkIncludeLines($value, 1, TRUE);
 			$files = array_merge($files, $includeData['files']);
 			$value = $includeData['typoscript'];
 		}
 
 		foreach ($this->config as &$value) {
-			$includeData = t3lib_TSparser::checkIncludeLines($value, 1, true);
+			$includeData = t3lib_TSparser::checkIncludeLines($value, 1, TRUE);
 			$files = array_merge($files, $includeData['files']);
 			$value = $includeData['typoscript'];
 		}
 
 		foreach ($this->editorcfg as &$value) {
-			$includeData = t3lib_TSparser::checkIncludeLines($value, 1, true);
+			$includeData = t3lib_TSparser::checkIncludeLines($value, 1, TRUE);
 			$files = array_merge($files, $includeData['files']);
 			$value = $includeData['typoscript'];
 		}
@@ -1030,22 +992,22 @@
 	 * @return	array		Constants array, modified
 	 * @todo	Apply caching to the parsed Page TSconfig. This is done in the other similar functions for both frontend and backend. However, since this functions works for BOTH frontend and backend we will have to either write our own local caching function or (more likely) detect if we are in FE or BE and use caching functions accordingly. Not having caching affects mostly the backend modules inside the "Template" module since the overhead in the frontend is only seen when TypoScript templates are parsed anyways (after which point they are cached anyways...)
 	 */
-	function mergeConstantsFromPageTSconfig($constArray)	{
+	function mergeConstantsFromPageTSconfig($constArray) {
 		$TSdataArray = array();
-		$TSdataArray[]=$GLOBALS['TYPO3_CONF_VARS']['BE']['defaultPageTSconfig'];	// Setting default configuration:
+		$TSdataArray[] = $GLOBALS['TYPO3_CONF_VARS']['BE']['defaultPageTSconfig']; // Setting default configuration:
 
-		for ($a=0;$a<=$this->outermostRootlineIndexWithTemplate;$a++)	{
+		for ($a = 0; $a <= $this->outermostRootlineIndexWithTemplate; $a++) {
-			$TSdataArray[]=$this->absoluteRootLine[$a]['TSconfig'];
+			$TSdataArray[] = $this->absoluteRootLine[$a]['TSconfig'];
 		}
 			// Parsing the user TS (or getting from cache)
 		$TSdataArray = t3lib_TSparser::checkIncludeLines_array($TSdataArray);
-		$userTS = implode(LF.'[GLOBAL]'.LF,$TSdataArray);
+		$userTS = implode(LF . '[GLOBAL]' . LF, $TSdataArray);
 
 		$parseObj = t3lib_div::makeInstance('t3lib_TSparser');
 		$parseObj->parse($userTS);
 
-		if (is_array($parseObj->setup['TSFE.']['constants.']))	{
+		if (is_array($parseObj->setup['TSFE.']['constants.'])) {
-			$constArray = t3lib_div::array_merge_recursive_overrule($constArray,$parseObj->setup['TSFE.']['constants.']);
+			$constArray = t3lib_div::array_merge_recursive_overrule($constArray, $parseObj->setup['TSFE.']['constants.']);
 		}
 		return $constArray;
 	}
@@ -1059,16 +1021,16 @@
 	 * @return	void
 	 * @see generateConfig()
 	 */
-	function flattenSetup($setupArray, $prefix, $resourceFlag)	{
+	function flattenSetup($setupArray, $prefix, $resourceFlag) {
-		if (is_array($setupArray))	{
+		if (is_array($setupArray)) {
 			foreach ($setupArray as $key => $val) {
-				if ($prefix || substr($key,0,16)!='TSConstantEditor')	{		// We don't want 'TSConstantEditor' in the flattend setup on the first level (190201)
+				if ($prefix || substr($key, 0, 16) != 'TSConstantEditor') { // We don't want 'TSConstantEditor' in the flattend setup on the first level (190201)
-					if (is_array($val))	{
+					if (is_array($val)) {
-						$this->flattenSetup($val,$prefix.$key, ($key=='file.'));
+						$this->flattenSetup($val, $prefix . $key, ($key == 'file.'));
 					} elseif ($resourceFlag) {
-						$this->flatSetup[$prefix.$key] = $this->getFileName($val);
+						$this->flatSetup[$prefix . $key] = $this->getFileName($val);
 					} else {
-						$this->flatSetup[$prefix.$key] = $val;
+						$this->flatSetup[$prefix . $key] = $val;
 					}
 				}
 			}
@@ -1082,16 +1044,18 @@
 	 * @return	string		The processed string with all constants found in $this->flatSetup as key/value pairs substituted.
 	 * @see generateConfig(), flattenSetup()
 	 */
-	function substituteConstants($all)	{
+	function substituteConstants($all) {
-		if ($this->tt_track)	$GLOBALS['TT']->setTSlogMessage('Constants to substitute: '.count($this->flatSetup));
+		if ($this->tt_track) {
+			$GLOBALS['TT']->setTSlogMessage('Constants to substitute: ' . count($this->flatSetup));
+		}
 
-		$noChange = false;
+		$noChange = FALSE;
-		// recursive substitution of constants (up to 10 nested levels)
+			// recursive substitution of constants (up to 10 nested levels)
 		for ($i = 0; $i < 10 && !$noChange; $i++) {
 			$old_all = $all;
 			$all = preg_replace_callback('/\{\$(.[^}]*)\}/', array($this, 'substituteConstantsCallBack'), $all);
 			if ($old_all == $all) {
-				$noChange = true;
+				$noChange = TRUE;
 			}
 		}
 
@@ -1106,19 +1070,11 @@
 	 * @see substituteConstants()
 	 */
 	function substituteConstantsCallBack($matches) {
-		// replace {$CONST} if found in $this->flatSetup, else leave unchanged
+			// replace {$CONST} if found in $this->flatSetup, else leave unchanged
 		return isset($this->flatSetup[$matches[1]]) && !is_array($this->flatSetup[$matches[1]]) ? $this->flatSetup[$matches[1]] : $matches[0];
 	}
 
 
-
-
-
-
-
-
-
-
 	/*******************************************************************
 	 *
 	 * Various API functions, used from elsewhere in the frontend classes
@@ -1136,62 +1092,62 @@
 	 * @see tslib_cObj::IMGTEXT(), tslib_menu::procesItemStates()
 	 * @link http://typo3.org/doc.0.html?&tx_extrepmgm_pi1[extUid]=270&tx_extrepmgm_pi1[tocEl]=289&cHash=6604390b37
 	 */
-	function splitConfArray($conf,$splitCount)	{
+	function splitConfArray($conf, $splitCount) {
 
 			// Initialize variables:
 		$splitCount = intval($splitCount);
-		$conf2 = Array();
+		$conf2 = array();
 
-		if ($splitCount && is_array($conf))	{
+		if ($splitCount && is_array($conf)) {
 
 				// Initialize output to carry at least the keys:
-			for ($aKey=0;$aKey<$splitCount;$aKey++)	{
+			for ($aKey = 0; $aKey < $splitCount; $aKey++) {
 				$conf2[$aKey] = array();
 			}
 
 				// Recursive processing of array keys:
-			foreach($conf as $cKey => $val)	{
+			foreach ($conf as $cKey => $val) {
-				if (is_array($val))	{
+				if (is_array($val)) {
-					$tempConf = $this->splitConfArray($val,$splitCount);
+					$tempConf = $this->splitConfArray($val, $splitCount);
-					foreach($tempConf as $aKey => $val)	{
+					foreach ($tempConf as $aKey => $val) {
 						$conf2[$aKey][$cKey] = $val;
 					}
 				} else {
 						// Splitting of all values on this level of the TypoScript object tree:
-					if (!strstr($val,'|*|') && !strstr($val,'||'))	{
+					if (!strstr($val, '|*|') && !strstr($val, '||')) {
-						for ($aKey=0;$aKey<$splitCount;$aKey++)	{
+						for ($aKey = 0; $aKey < $splitCount; $aKey++) {
 							$conf2[$aKey][$cKey] = $val;
 						}
 					} else {
-						$main = explode ('|*|',$val);
+						$main = explode('|*|', $val);
 						$mainCount = count($main);
 
 						$lastC = 0;
 						$middleC = 0;
 						$firstC = 0;
 
-						if ($main[0])	{
+						if ($main[0]) {
-							$first = explode('||',$main[0]);
+							$first = explode('||', $main[0]);
 							$firstC = count($first);
 						}
-						if ($main[1])	{
+						if ($main[1]) {
-							$middle = explode('||',$main[1]);
+							$middle = explode('||', $main[1]);
 							$middleC = count($middle);
 						}
-						if ($main[2])	{
+						if ($main[2]) {
-							$last = explode('||',$main[2]);
+							$last = explode('||', $main[2]);
 							$lastC = count($last);
 							$value = $last[0];
 						}
 
-						for ($aKey=0;$aKey<$splitCount;$aKey++)	{
+						for ($aKey = 0; $aKey < $splitCount; $aKey++) {
 							if ($firstC && isset($first[$aKey])) {
 								$value = $first[$aKey];
 							} elseif ($middleC) {
-								$value = $middle[($aKey-$firstC)%$middleC];
+								$value = $middle[($aKey - $firstC) % $middleC];
 							}
-							if ($lastC && $lastC>=($splitCount-$aKey))	{
+							if ($lastC && $lastC >= ($splitCount - $aKey)) {
-								$value = $last[$lastC-($splitCount-$aKey)];
+								$value = $last[$lastC - ($splitCount - $aKey)];
 							}
 							$conf2[$aKey][$cKey] = trim($value);
 						}
@@ -1209,35 +1165,41 @@
 	 * @param	string		TypoScript "resource" data type value.
 	 * @return	string		Resulting filename, if any.
 	 */
-	function getFileName($fileFromSetup)	{
+	function getFileName($fileFromSetup) {
 		$file = trim($fileFromSetup);
-		if (!$file)	{
+		if (!$file) {
 			return;
-		} elseif (strstr($file,'../'))	{
+		} elseif (strstr($file, '../')) {
-			if ($this->tt_track)	$GLOBALS['TT']->setTSlogMessage('File path "'.$file.'" contained illegal string "../"!',3);
+			if ($this->tt_track) {
+				$GLOBALS['TT']->setTSlogMessage('File path "' . $file . '" contained illegal string "../"!', 3);
+			}
 			return;
 		}
 			// cache
 		$hash = md5($file);
-		if (isset($this->fileCache[$hash]))	{
+		if (isset($this->fileCache[$hash])) {
 			return $this->fileCache[$hash];
 		}
 
-		if (!strcmp(substr($file,0,4),'EXT:'))	{
+		if (!strcmp(substr($file, 0, 4), 'EXT:')) {
-			$newFile='';
+			$newFile = '';
-			list($extKey,$script)=explode('/',substr($file,4),2);
+			list($extKey, $script) = explode('/', substr($file, 4), 2);
-			if ($extKey && t3lib_extMgm::isLoaded($extKey))	{
+			if ($extKey && t3lib_extMgm::isLoaded($extKey)) {
-				$extPath=t3lib_extMgm::extPath($extKey);
+				$extPath = t3lib_extMgm::extPath($extKey);
-				$newFile=substr($extPath,strlen(PATH_site)).$script;
+				$newFile = substr($extPath, strlen(PATH_site)) . $script;
 			}
-			if (!@is_file(PATH_site.$newFile))	{
+			if (!@is_file(PATH_site . $newFile)) {
-				if ($this->tt_track) $GLOBALS['TT']->setTSlogMessage('Extension media file "'.$newFile.'" was not found!',3);
+				if ($this->tt_track) {
+					$GLOBALS['TT']->setTSlogMessage('Extension media file "' . $newFile . '" was not found!', 3);
+				}
 				return;
-			} else $file=$newFile;
+			} else {
+				$file = $newFile;
-		}
+			}
+		}
 
 			// find
-		if (strpos($file, '/') !== false) {
+		if (strpos($file, '/') !== FALSE) {
 				// if the file is in the media/ folder but it doesn't exist,
 				// it is assumed that it's in the tslib folder
 			if (t3lib_div::isFirstPartOfStr($file, 'media/') && !is_file($this->getFileName_backPath . $file)) {
@@ -1246,28 +1208,36 @@
 			if (is_file($this->getFileName_backPath . $file)) {
 				$outFile = $file;
 				$fileInfo = t3lib_div::split_fileref($outFile);
-				$OK=0;
+				$OK = 0;
 				foreach ($this->allowedPaths as $val) {
-					if (substr($fileInfo['path'], 0, strlen($val))==$val) {
+					if (substr($fileInfo['path'], 0, strlen($val)) == $val) {
-						$OK=1;
+						$OK = 1;
 						break;
 					}
 				}
-				if ($OK)	{
+				if ($OK) {
-					$this->fileCache[$hash]=$outFile;
+					$this->fileCache[$hash] = $outFile;
 					return $outFile;
-				} elseif ($this->tt_track) $GLOBALS['TT']->setTSlogMessage('"'.$file.'" was not located in the allowed paths: ('.implode(',',$this->allowedPaths).')',3);
-			} elseif ($this->tt_track) $GLOBALS['TT']->setTSlogMessage('"'.$this->getFileName_backPath.$file.'" is not a file (non-uploads/.. resource, did not exist).',3);
+				} elseif ($this->tt_track) {
+					$GLOBALS['TT']->setTSlogMessage('"' . $file . '" was not located in the allowed paths: (' . implode(',', $this->allowedPaths) . ')', 3);
+				}
+			} elseif ($this->tt_track) {
+				$GLOBALS['TT']->setTSlogMessage('"' . $this->getFileName_backPath . $file . '" is not a file (non-uploads/.. resource, did not exist).', 3);
+			}
-		} else {		// Here it is uploaded media:
+		} else { // Here it is uploaded media:
-			$outFile = $this->extractFromResources($this->setup['resources'],$file);
+			$outFile = $this->extractFromResources($this->setup['resources'], $file);
-			if ($outFile)	{
+			if ($outFile) {
-			 	if (@is_file($this->uplPath.$outFile))	{
+				if (@is_file($this->uplPath . $outFile)) {
-					$this->fileCache[$hash] = $this->uplPath.$outFile;
+					$this->fileCache[$hash] = $this->uplPath . $outFile;
-					return $this->uplPath.$outFile;
+					return $this->uplPath . $outFile;
-				} elseif ($this->tt_track) $GLOBALS['TT']->setTSlogMessage('"'.$this->uplPath.$outFile.'" is not a file (did not exist).',3);
-			} elseif ($this->tt_track) $GLOBALS['TT']->setTSlogMessage('"'.$file.'" is not a file (uploads/.. resource).',3);
+				} elseif ($this->tt_track) {
+					$GLOBALS['TT']->setTSlogMessage('"' . $this->uplPath . $outFile . '" is not a file (did not exist).', 3);
-		}
+				}
+			} elseif ($this->tt_track) {
+				$GLOBALS['TT']->setTSlogMessage('"' . $file . '" is not a file (uploads/.. resource).', 3);
-	}
+			}
+		}
+	}
 
 	/**
 	 * Searches for the TypoScript resource filename in the list of resource filenames.
@@ -1278,15 +1248,15 @@
 	 * @access private
 	 * @see getFileName()
 	 */
-	function extractFromResources($res,$file)	{
+	function extractFromResources($res, $file) {
-		if (t3lib_div::inList($res,$file))	{
+		if (t3lib_div::inList($res, $file)) {
 			$outFile = $file;
-		} elseif (strstr($file,'*')) {
+		} elseif (strstr($file, '*')) {
-			$fileparts=explode('*',$file);
+			$fileparts = explode('*', $file);
-			$c=count($fileparts);
+			$c = count($fileparts);
 			$files = t3lib_div::trimExplode(',', $res);
 			foreach ($files as $file) {
-				if (preg_match('/^'.quotemeta($fileparts[0]).'.*'.quotemeta($fileparts[$c-1]).'$/', $file)) {
+				if (preg_match('/^' . quotemeta($fileparts[0]) . '.*' . quotemeta($fileparts[$c - 1]) . '$/', $file)) {
 					$outFile = $file;
 					break;
 				}
@@ -1305,7 +1275,7 @@
 	 * @deprecated since TYPO3 3.6, this function will be removed in TYPO3 4.6.
 	 * @internal
 	 */
-	function checkFile($name,$menuArr)	{
+	function checkFile($name, $menuArr) {
 		t3lib_div::logDeprecatedFunction();
 
 		foreach ($menuArr as $aKey => $value) {
@@ -1323,18 +1293,18 @@
 	 * @return	string		The page title on the form "[sitetitle]: [input-title]". Not htmlspecialchar()'ed.
 	 * @see tslib_fe::tempPageCacheContent(), TSpagegen::renderContentWithHeader()
 	 */
-	function printTitle($title,$no_title=0,$titleFirst=0)	{
+	function printTitle($title, $no_title = 0, $titleFirst = 0) {
-		$st = trim($this->setup['sitetitle']) ? $this->setup['sitetitle']:'';
+		$st = trim($this->setup['sitetitle']) ? $this->setup['sitetitle'] : '';
 		$title = $no_title ? '' : $title;
-		if ($titleFirst)	{
+		if ($titleFirst) {
-			$temp=$st;
+			$temp = $st;
-			$st=$title;
+			$st = $title;
-			$title=$temp;
+			$title = $temp;
 		}
-		if ($title && $st)	{
+		if ($title && $st) {
-			return $st.': '.$title;
+			return $st . ': ' . $title;
 		} else {
-			return $st.$title;
+			return $st . $title;
 		}
 	}
 
@@ -1346,9 +1316,9 @@
 	 * @return	string		The content returned
 	 * @see tslib_cObj::fileResource(), tslib_cObj::MULTIMEDIA(), t3lib_div::getUrl()
 	 */
-	function fileContent($fName)	{
+	function fileContent($fName) {
 		$incFile = $this->getFileName($fName);
-		if ($incFile)	{
+		if ($incFile) {
 			return @file_get_contents($incFile);
 		}
 	}
@@ -1361,12 +1331,14 @@
 	 * @return	string		Wrapped input string
 	 * @see tslib_menu, tslib_cObj::wrap()
 	 */
-	function wrap($content,$wrap)	{
+	function wrap($content, $wrap) {
-		if ($wrap)	{
+		if ($wrap) {
 			$wrapArr = explode('|', $wrap);
-			return trim($wrapArr[0]).$content.trim($wrapArr[1]);
+			return trim($wrapArr[0]) . $content . trim($wrapArr[1]);
-		} else return $content;
+		} else {
+			return $content;
-	}
+		}
+	}
 
 	/**
 	 * Removes the "?" of input string IF the "?" is the last character.
@@ -1375,9 +1347,9 @@
 	 * @return	string		Output string, free of "?" in the end, if any such character.
 	 * @see linkData(), tslib_frameset::frameParams()
 	 */
-	function removeQueryString($url)	{
+	function removeQueryString($url) {
-		if (substr($url,-1)=='?')	{
+		if (substr($url, -1) == '?') {
-			return substr($url,0,-1);
+			return substr($url, 0, -1);
 		} else {
 			return $url;
 		}
@@ -1392,7 +1364,7 @@
 	 * @return	array		An array with all integer properties listed in numeric order.
 	 * @see tslib_cObj::cObjGet(), tslib_gifBuilder, tslib_imgmenu::makeImageMap()
 	 */
-	function sortedKeyList($setupArr, $acceptOnlyProperties=false) {
+	function sortedKeyList($setupArr, $acceptOnlyProperties = FALSE) {
 		$keyArr = array();
 		$setupArrKeys = array_keys($setupArr);
 		foreach ($setupArrKeys as $key) {
@@ -1412,24 +1384,18 @@
 	 * @param	string		A list of UIDs for which the rootline-level should get returned
 	 * @return	integer	The level in the rootline. If more than one page was given the lowest level will get returned.
 	 */
-	function getRootlineLevel($list)	{
+	function getRootlineLevel($list) {
 		$idx = 0;
-		foreach($this->rootLine as $page)	{
+		foreach ($this->rootLine as $page) {
 			if (t3lib_div::inList($list, $page['uid'])) {
 				return $idx;
 			}
 			$idx++;
 		}
-		return false;
+		return FALSE;
 	}
 
 
-
-
-
-
-
-
 	/*******************************************************************
 	 *
 	 * Functions for creating links
@@ -1453,53 +1419,57 @@
 	 * @return	array		Contains keys like "totalURL", "url", "sectionIndex", "linkVars", "no_cache", "type", "target" of which "totalURL" is normally the value you would use while the other keys contains various parts that was used to construct "totalURL"
 	 * @see tslib_frameset::frameParams(), tslib_cObj::typoLink(), tslib_cObj::SEARCHRESULT(), TSpagegen::pagegenInit(), tslib_menu::link()
 	 */
-	function linkData($page, $oTarget, $no_cache, $script, $overrideArray='', $addParams='', $typeOverride='', $targetDomain='') {
+	function linkData($page, $oTarget, $no_cache, $script, $overrideArray = '', $addParams = '', $typeOverride = '', $targetDomain = '') {
 		global $TYPO3_CONF_VARS;
 
-		$LD = Array();
+		$LD = array();
 
 			// Overriding some fields in the page record and still preserves the values by adding them as parameters. Little strange function.
-		if (is_array($overrideArray))	{
+		if (is_array($overrideArray)) {
-			foreach($overrideArray as $theKey => $theNewVal)	{
+			foreach ($overrideArray as $theKey => $theNewVal) {
-				$addParams.= '&real_'.$theKey.'='.rawurlencode($page[$theKey]);
+				$addParams .= '&real_' . $theKey . '=' . rawurlencode($page[$theKey]);
 				$page[$theKey] = $theNewVal;
 			}
 		}
 
 			// Adding Mount Points, "&MP=", parameter for the current page if any is set:
-		if (!strstr($addParams,'&MP='))	{
+		if (!strstr($addParams, '&MP=')) {
-			if (trim($GLOBALS['TSFE']->MP_defaults[$page['uid']]))	{	// Looking for hardcoded defaults:
+			if (trim($GLOBALS['TSFE']->MP_defaults[$page['uid']])) { // Looking for hardcoded defaults:
-				$addParams.= '&MP='.rawurlencode(trim($GLOBALS['TSFE']->MP_defaults[$page['uid']]));
+				$addParams .= '&MP=' . rawurlencode(trim($GLOBALS['TSFE']->MP_defaults[$page['uid']]));
-			} elseif ($GLOBALS['TSFE']->config['config']['MP_mapRootPoints']) {		// Else look in automatically created map:
+			} elseif ($GLOBALS['TSFE']->config['config']['MP_mapRootPoints']) { // Else look in automatically created map:
 				$m = $this->getFromMPmap($page['uid']);
-				if ($m)	{
+				if ($m) {
-					$addParams.= '&MP='.rawurlencode($m);
+					$addParams .= '&MP=' . rawurlencode($m);
 				}
 			}
 		}
 
 			// Setting ID/alias:
-		if (!$script)	{$script = $GLOBALS['TSFE']->config['mainScript'];}
+		if (!$script) {
+			$script = $GLOBALS['TSFE']->config['mainScript'];
+		}
-		if ($page['alias'])	{
+		if ($page['alias']) {
-			$LD['url'] = $script.'?id='.rawurlencode($page['alias']);
+			$LD['url'] = $script . '?id=' . rawurlencode($page['alias']);
 		} else {
-			$LD['url'] = $script.'?id='.$page['uid'];
+			$LD['url'] = $script . '?id=' . $page['uid'];
 		}
 			// Setting target
 		$LD['target'] = trim($page['target']) ? trim($page['target']) : $oTarget;
 
 			// typeNum
-		$typeNum = $this->setup[$LD['target'].'.']['typeNum'];
+		$typeNum = $this->setup[$LD['target'] . '.']['typeNum'];
-		if (!t3lib_div::testInt($typeOverride) && intval($GLOBALS['TSFE']->config['config']['forceTypeValue']))	{
+		if (!t3lib_div::testInt($typeOverride) && intval($GLOBALS['TSFE']->config['config']['forceTypeValue'])) {
 			$typeOverride = intval($GLOBALS['TSFE']->config['config']['forceTypeValue']);
 		}
-		if (strcmp($typeOverride,''))	{ $typeNum = $typeOverride; }	// Override...
+		if (strcmp($typeOverride, '')) {
+			$typeNum = $typeOverride;
+		} // Override...
-		if ($typeNum)	{
+		if ($typeNum) {
-			$LD['type'] = '&type='.intval($typeNum);
+			$LD['type'] = '&type=' . intval($typeNum);
 		} else {
 			$LD['type'] = '';
 		}
-		$LD['orig_type'] = $LD['type'];		// Preserving the type number.
+		$LD['orig_type'] = $LD['type']; // Preserving the type number.
 
 			// noCache
 		$LD['no_cache'] = (trim($page['no_cache']) || $no_cache) ? '&no_cache=1' : '';
@@ -1507,32 +1477,32 @@
 			// linkVars
 		if ($GLOBALS['TSFE']->config['config']['uniqueLinkVars']) {
 			if ($addParams) {
-				$LD['linkVars'] = t3lib_div::implodeArrayForUrl('',t3lib_div::explodeUrl2Array($GLOBALS['TSFE']->linkVars.$addParams));
+				$LD['linkVars'] = t3lib_div::implodeArrayForUrl('', t3lib_div::explodeUrl2Array($GLOBALS['TSFE']->linkVars . $addParams));
 			} else {
 				$LD['linkVars'] = $GLOBALS['TSFE']->linkVars;
 			}
 		} else {
-			$LD['linkVars'] = $GLOBALS['TSFE']->linkVars.$addParams;
+			$LD['linkVars'] = $GLOBALS['TSFE']->linkVars . $addParams;
 		}
 
 			// Add absRefPrefix if exists.
-		$LD['url'] = $GLOBALS['TSFE']->absRefPrefix.$LD['url'];
+		$LD['url'] = $GLOBALS['TSFE']->absRefPrefix . $LD['url'];
 
 			// If the special key 'sectionIndex_uid' (added 'manually' in tslib/menu.php to the page-record) is set, then the link jumps directly to a section on the page.
-		$LD['sectionIndex'] = $page['sectionIndex_uid'] ? '#c'.$page['sectionIndex_uid'] : '';
+		$LD['sectionIndex'] = $page['sectionIndex_uid'] ? '#c' . $page['sectionIndex_uid'] : '';
 
 			// Compile the normal total url
-		$LD['totalURL']= $this->removeQueryString($LD['url'].$LD['type'].$LD['no_cache'].$LD['linkVars'].$GLOBALS['TSFE']->getMethodUrlIdToken).$LD['sectionIndex'];
+		$LD['totalURL'] = $this->removeQueryString($LD['url'] . $LD['type'] . $LD['no_cache'] . $LD['linkVars'] . $GLOBALS['TSFE']->getMethodUrlIdToken) . $LD['sectionIndex'];
 
 			// Call post processing function for link rendering:
-		if (is_array($TYPO3_CONF_VARS['SC_OPTIONS']['t3lib/class.t3lib_tstemplate.php']['linkData-PostProc']))	{
+		if (is_array($TYPO3_CONF_VARS['SC_OPTIONS']['t3lib/class.t3lib_tstemplate.php']['linkData-PostProc'])) {
 			$_params = array(
-							'LD' => &$LD,
+				'LD' => &$LD,
-							'args' => array('page'=>$page, 'oTarget'=>$oTarget, 'no_cache'=>$no_cache, 'script'=>$script, 'overrideArray'=>$overrideArray, 'addParams'=>$addParams, 'typeOverride'=>$typeOverride,'targetDomain'=>$targetDomain),
+				'args' => array('page' => $page, 'oTarget' => $oTarget, 'no_cache' => $no_cache, 'script' => $script, 'overrideArray' => $overrideArray, 'addParams' => $addParams, 'typeOverride' => $typeOverride, 'targetDomain' => $targetDomain),
-							'typeNum' => $typeNum
-						);
+				'typeNum' => $typeNum
+			);
-			foreach ($TYPO3_CONF_VARS['SC_OPTIONS']['t3lib/class.t3lib_tstemplate.php']['linkData-PostProc'] as $_funcRef)	{
+			foreach ($TYPO3_CONF_VARS['SC_OPTIONS']['t3lib/class.t3lib_tstemplate.php']['linkData-PostProc'] as $_funcRef) {
-				t3lib_div::callUserFunction($_funcRef,$_params,$this);
+				t3lib_div::callUserFunction($_funcRef, $_params, $this);
 			}
 		}
 
@@ -1549,29 +1519,29 @@
 	 * @see initMPmap_create()
 	 * @todo Implement some caching of the result between hits. (more than just the memory caching used here)
 	 */
-	function getFromMPmap($pageId=0)	{
+	function getFromMPmap($pageId = 0) {
 
 			// Create map if not found already:
-		if (!is_array($this->MPmap))	{
+		if (!is_array($this->MPmap)) {
 			$this->MPmap = array();
 
-			$rootPoints = t3lib_div::trimExplode(',', strtolower($GLOBALS['TSFE']->config['config']['MP_mapRootPoints']),1);
+			$rootPoints = t3lib_div::trimExplode(',', strtolower($GLOBALS['TSFE']->config['config']['MP_mapRootPoints']), 1);
-			foreach($rootPoints as $p)	{	// Traverse rootpoints:
+			foreach ($rootPoints as $p) { // Traverse rootpoints:
-				if ($p == 'root')	{
+				if ($p == 'root') {
 					$p = $this->rootLine[0]['uid'];
 					$initMParray = array();
-					if ($this->rootLine[0]['_MOUNT_OL'] && $this->rootLine[0]['_MP_PARAM'])	{
+					if ($this->rootLine[0]['_MOUNT_OL'] && $this->rootLine[0]['_MP_PARAM']) {
 						$initMParray[] = $this->rootLine[0]['_MP_PARAM'];
 					}
 				}
-				$this->initMPmap_create($p,$initMParray);
+				$this->initMPmap_create($p, $initMParray);
 			}
 		}
 
 			// Finding MP var for Page ID:
-		if ($pageId)	{
+		if ($pageId) {
-			if (is_array($this->MPmap[$pageId]) && count($this->MPmap[$pageId]))	{
+			if (is_array($this->MPmap[$pageId]) && count($this->MPmap[$pageId])) {
-				return implode(',',$this->MPmap[$pageId]);
+				return implode(',', $this->MPmap[$pageId]);
 			}
 		}
 	}
@@ -1585,19 +1555,21 @@
 	 * @return	void
 	 * @see getFromMPvar()
 	 */
-	function initMPmap_create($id,$MP_array=array(),$level=0)	{
+	function initMPmap_create($id, $MP_array = array(), $level = 0) {
 
 		$id = intval($id);
-		if($id<=0)	return;
+		if ($id <= 0) {
+			return;
+		}
 
 			// First level, check id
-		if (!$level)	{
+		if (!$level) {
 
 				// Find mount point if any:
 			$mount_info = $GLOBALS['TSFE']->sys_page->getMountPointInfo($id);
 
 				// Overlay mode:
-			if (is_array($mount_info) && $mount_info['overlay'])	{
+			if (is_array($mount_info) && $mount_info['overlay']) {
 				$MP_array[] = $mount_info['MPvar'];
 				$id = $mount_info['mount_pid'];
 			}
@@ -1606,24 +1578,24 @@
 			$this->MPmap[$id] = $MP_array;
 
 				// Normal mode:
-			if (is_array($mount_info) && !$mount_info['overlay'])	{
+			if (is_array($mount_info) && !$mount_info['overlay']) {
 				$MP_array[] = $mount_info['MPvar'];
 				$id = $mount_info['mount_pid'];
 			}
 		}
 
-		if ($id && $level<20)	{
+		if ($id && $level < 20) {
 
 			$nextLevelAcc = array();
 
 				// Select and traverse current level pages:
 			$res = $GLOBALS['TYPO3_DB']->exec_SELECTquery(
-						'uid,pid,doktype,mount_pid,mount_pid_ol',
-						'pages',
+				'uid,pid,doktype,mount_pid,mount_pid_ol',
+				'pages',
-						'pid='.intval($id).' AND deleted=0 AND doktype!=' . t3lib_pageSelect::DOKTYPE_RECYCLER .
+				'pid=' . intval($id) . ' AND deleted=0 AND doktype!=' . t3lib_pageSelect::DOKTYPE_RECYCLER .
-							' AND doktype!=' . t3lib_pageSelect::DOKTYPE_BE_USER_SECTION
-					);
+				' AND doktype!=' . t3lib_pageSelect::DOKTYPE_BE_USER_SECTION
+			);
-			while ($row = $GLOBALS['TYPO3_DB']->sql_fetch_assoc($res))	{
+			while ($row = $GLOBALS['TYPO3_DB']->sql_fetch_assoc($res)) {
 
 					// Find mount point if any:
 				$next_id = $row['uid'];
@@ -1631,38 +1603,38 @@
 				$mount_info = $GLOBALS['TSFE']->sys_page->getMountPointInfo($next_id, $row);
 
 					// Overlay mode:
-				if (is_array($mount_info) && $mount_info['overlay'])	{
+				if (is_array($mount_info) && $mount_info['overlay']) {
 					$next_MP_array[] = $mount_info['MPvar'];
 					$next_id = $mount_info['mount_pid'];
 				}
 
-				if (!isset($this->MPmap[$next_id]))	{
+				if (!isset($this->MPmap[$next_id])) {
 
 						// Set mapping information for this level:
 					$this->MPmap[$next_id] = $next_MP_array;
 
 						// Normal mode:
-					if (is_array($mount_info) && !$mount_info['overlay'])	{
+					if (is_array($mount_info) && !$mount_info['overlay']) {
 						$next_MP_array[] = $mount_info['MPvar'];
 						$next_id = $mount_info['mount_pid'];
 					}
 
 						// Register recursive call
 						// (have to do it this way since ALL of the current level should be registered BEFORE the sublevel at any time)
-					$nextLevelAcc[] = array($next_id,$next_MP_array);
+					$nextLevelAcc[] = array($next_id, $next_MP_array);
 				}
 			}
 
 				// Call recursively, if any:
-			foreach($nextLevelAcc as $pSet)	{
+			foreach ($nextLevelAcc as $pSet) {
-				$this->initMPmap_create($pSet[0],$pSet[1],$level+1);
+				$this->initMPmap_create($pSet[0], $pSet[1], $level + 1);
 			}
 		}
 	}
 }
 
 
-if (defined('TYPO3_MODE') && $TYPO3_CONF_VARS[TYPO3_MODE]['XCLASS']['t3lib/class.t3lib_tstemplate.php'])	{
+if (defined('TYPO3_MODE') && $TYPO3_CONF_VARS[TYPO3_MODE]['XCLASS']['t3lib/class.t3lib_tstemplate.php']) {
 	include_once($TYPO3_CONF_VARS[TYPO3_MODE]['XCLASS']['t3lib/class.t3lib_tstemplate.php']);
 }
 
